Loading...
Searching...
No Matches
lz4.h File Reference
`#include <stddef.h>`
Include dependency graph for lz4.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | LZ4_stream_t_internal
union | LZ4_stream_u
struct | LZ4_streamDecode_t_internal
union | LZ4_streamDecode_u

## Macros

#define | LZ4_H_2983827168210
#define | LZ4LIB_VISIBILITY
#define | LZ4LIB_API LZ4LIB_VISIBILITY
#define | LZ4_FREESTANDING 0
#define | LZ4_VERSION_MAJOR 1 /* for breaking interface changes */
#define | LZ4_VERSION_MINOR
#define | LZ4_VERSION_RELEASE 0 /* for tweaks, bug-fixes, or development */
#define | LZ4_VERSION_NUMBER
#define | LZ4_LIB_VERSION LZ4_VERSION_MAJOR.LZ4_VERSION_MINOR.LZ4_VERSION_RELEASE
#define | LZ4_QUOTE(str)
#define | LZ4_EXPAND_AND_QUOTE(str)
#define | LZ4_VERSION_STRING LZ4_EXPAND_AND_QUOTE(LZ4_LIB_VERSION) /* requires v1.7.3+ */
#define | LZ4_MEMORY_USAGE LZ4_MEMORY_USAGE_DEFAULT
#define | LZ4_MEMORY_USAGE_MIN 10
#define | LZ4_MEMORY_USAGE_DEFAULT 14
#define | LZ4_MEMORY_USAGE_MAX 20
#define | LZ4_MAX_INPUT_SIZE 0x7E000000 /* 2 113 929 216 bytes */
#define | LZ4_COMPRESSBOUND(isize)
#define | LZ4_DECODER_RING_BUFFER_SIZE(maxBlockSize)
#define | LZ4_H_98237428734687
#define | LZ4_HASHLOG (LZ4_MEMORY_USAGE - 2)
#define | LZ4_HASHTABLESIZE (1 << LZ4_MEMORY_USAGE)
#define | LZ4_HASH_SIZE_U32 (1 << LZ4_HASHLOG) /* required as macro for static allocation */
#define | LZ4_STREAM_MINSIZE
#define | LZ4_STREAMDECODE_MINSIZE 32
#define | LZ4_DEPRECATED(message)

## Typedefs

typedef union LZ4_stream_u | LZ4_stream_t
typedef union LZ4_streamDecode_u | LZ4_streamDecode_t
typedef signed char | LZ4_i8
typedef unsigned char | LZ4_byte
typedef unsigned short | LZ4_u16
typedef unsigned int | LZ4_u32
typedef struct LZ4_stream_t_internal | LZ4_stream_t_internal

## Functions

int | LZ4_versionNumber (void)
const char * | LZ4_versionString (void)
int | LZ4_compress_default (const char *src, char *dst, int srcSize, int dstCapacity)
int | LZ4_decompress_safe (const char *src, char *dst, int compressedSize, int dstCapacity)
int | LZ4_compressBound (int inputSize)
int | LZ4_compress_fast (const char *src, char *dst, int srcSize, int dstCapacity, int acceleration)
int | LZ4_sizeofState (void)
int | LZ4_compress_fast_extState (void *state, const char *src, char *dst, int srcSize, int dstCapacity, int acceleration)
int | LZ4_compress_destSize (const char *src, char *dst, int *srcSizePtr, int targetDstSize)
int | LZ4_decompress_safe_partial (const char *src, char *dst, int srcSize, int targetOutputSize, int dstCapacity)
LZ4_stream_t * | LZ4_createStream (void)
int | LZ4_freeStream (LZ4_stream_t *streamPtr)
void | LZ4_resetStream_fast (LZ4_stream_t *streamPtr)
int | LZ4_loadDict (LZ4_stream_t *streamPtr, const char *dictionary, int dictSize)
int | LZ4_loadDictSlow (LZ4_stream_t *streamPtr, const char *dictionary, int dictSize)
void | LZ4_attach_dictionary (LZ4_stream_t *workingStream, const LZ4_stream_t *dictionaryStream)
int | LZ4_compress_fast_continue (LZ4_stream_t *streamPtr, const char *src, char *dst, int srcSize, int dstCapacity, int acceleration)
int | LZ4_saveDict (LZ4_stream_t *streamPtr, char *safeBuffer, int maxDictSize)
LZ4_streamDecode_t * | LZ4_createStreamDecode (void)
int | LZ4_freeStreamDecode (LZ4_streamDecode_t *LZ4_stream)
int | LZ4_setStreamDecode (LZ4_streamDecode_t *LZ4_streamDecode, const char *dictionary, int dictSize)
int | LZ4_decoderRingBufferSize (int maxBlockSize)
int | LZ4_decompress_safe_continue (LZ4_streamDecode_t *LZ4_streamDecode, const char *src, char *dst, int srcSize, int dstCapacity)
int | LZ4_decompress_safe_usingDict (const char *src, char *dst, int srcSize, int dstCapacity, const char *dictStart, int dictSize)
int | LZ4_decompress_safe_partial_usingDict (const char *src, char *dst, int compressedSize, int targetOutputSize, int maxOutputSize, const char *dictStart, int dictSize)
LZ4_stream_t * | LZ4_initStream (void *stateBuffer, size_t size)
int | LZ4_compress (const char *src, char *dest, int srcSize)
int | LZ4_compress_limitedOutput (const char *src, char *dest, int srcSize, int maxOutputSize)
int | LZ4_compress_withState (void *state, const char *source, char *dest, int inputSize)
int | LZ4_compress_limitedOutput_withState (void *state, const char *source, char *dest, int inputSize, int maxOutputSize)
int | LZ4_compress_continue (LZ4_stream_t *LZ4_streamPtr, const char *source, char *dest, int inputSize)
int | LZ4_compress_limitedOutput_continue (LZ4_stream_t *LZ4_streamPtr, const char *source, char *dest, int inputSize, int maxOutputSize)
int | LZ4_uncompress (const char *source, char *dest, int outputSize)
int | LZ4_uncompress_unknownOutputSize (const char *source, char *dest, int isize, int maxOutputSize)
void * | LZ4_create (char *inputBuffer)
int | LZ4_sizeofStreamState (void)
int | LZ4_resetStreamState (void *state, char *inputBuffer)
char * | LZ4_slideInputBuffer (void *state)
int | LZ4_decompress_safe_withPrefix64k (const char *src, char *dst, int compressedSize, int maxDstSize)
int | LZ4_decompress_fast_withPrefix64k (const char *src, char *dst, int originalSize)
int | LZ4_decompress_fast (const char *src, char *dst, int originalSize)
int | LZ4_decompress_fast_continue (LZ4_streamDecode_t *LZ4_streamDecode, const char *src, char *dst, int originalSize)
int | LZ4_decompress_fast_usingDict (const char *src, char *dst, int originalSize, const char *dictStart, int dictSize)
void | LZ4_resetStream (LZ4_stream_t *streamPtr)

## Macro Definition Documentation

## LZ4_COMPRESSBOUND

#define LZ4_COMPRESSBOUND | ( |  | isize | ) |

Value:
((unsigned)(isize) > (unsigned)LZ4_MAX_INPUT_SIZE \
? 0 \
: (isize) + ((isize) / 255) + 16)
LZ4_MAX_INPUT_SIZE
#define LZ4_MAX_INPUT_SIZE
Definition lz4.h:241

Definition at line 242 of file lz4.h.

Referenced by LZ4_sizeofState().

## LZ4_DECODER_RING_BUFFER_SIZE

#define LZ4_DECODER_RING_BUFFER_SIZE | ( |  | maxBlockSize | ) |

Value:
(65536 + 14 + \
(maxBlockSize)) /* for static allocation; maxBlockSize presumed valid */

Definition at line 566 of file lz4.h.

## LZ4_DEPRECATED

#define LZ4_DEPRECATED | ( |  | message | ) |

Value:
/* disabled */

Deprecation warnings

Deprecated functions make the compiler generate a warning when invoked. This is meant to invite users to update their source code. Should deprecation warnings be a problem, it is generally possible to disable them, typically with -Wno-deprecated-declarations for gcc or _CRT_SECURE_NO_WARNINGS in Visual.

Another method is to define LZ4_DISABLE_DEPRECATE_WARNINGS before including the header file.

Definition at line 910 of file lz4.h.

Referenced by LZ4_compress_continue(), LZ4_compress_limitedOutput(), LZ4_compress_limitedOutput_withState(), LZ4_compress_withState(), LZ4_create(), LZ4_decompress_fast(), LZ4_decompress_fast_continue(), LZ4_decompress_fast_withPrefix64k(), LZ4_resetStreamState(), LZ4_sizeofStreamState(), LZ4_slideInputBuffer(), LZ4_uncompress(), and LZ4_uncompress_unknownOutputSize().

## LZ4_EXPAND_AND_QUOTE

#define LZ4_EXPAND_AND_QUOTE | ( |  | str | ) |

Value:
LZ4_QUOTE(str)
LZ4_QUOTE
#define LZ4_QUOTE(str)
Definition lz4.h:144

Definition at line 145 of file lz4.h.

## LZ4_FREESTANDING

#define LZ4_FREESTANDING 0

LZ4_FREESTANDING : When this macro is set to 1, it enables "freestanding mode" that is suitable for typical freestanding environment which doesn't support standard C library.

- LZ4_FREESTANDING is a compile-time switch.
- It requires the following macros to be defined: LZ4_memcpy, LZ4_memmove, LZ4_memset.
- It only enables LZ4/HC functions which don't use heap. All LZ4F_* functions are not supported.
- See tests/freestanding.c to check its basic setup.

Definition at line 130 of file lz4.h.

## LZ4_H_2983827168210

#define LZ4_H_2983827168210

Definition at line 40 of file lz4.h.

## LZ4_H_98237428734687

#define LZ4_H_98237428734687

Definition at line 791 of file lz4.h.

## LZ4_HASH_SIZE_U32

#define LZ4_HASH_SIZE_U32 (1 << LZ4_HASHLOG) /* required as macro for static allocation */

Definition at line 803 of file lz4.h.

## LZ4_HASHLOG

#define LZ4_HASHLOG (LZ4_MEMORY_USAGE - 2)

Definition at line 801 of file lz4.h.

## LZ4_HASHTABLESIZE

#define LZ4_HASHTABLESIZE (1 << LZ4_MEMORY_USAGE)

Definition at line 802 of file lz4.h.

## LZ4_LIB_VERSION

#define LZ4_LIB_VERSION LZ4_VERSION_MAJOR.LZ4_VERSION_MINOR.LZ4_VERSION_RELEASE

Definition at line 143 of file lz4.h.

## LZ4_MAX_INPUT_SIZE

#define LZ4_MAX_INPUT_SIZE 0x7E000000 /* 2 113 929 216 bytes */

Definition at line 241 of file lz4.h.

## LZ4_MEMORY_USAGE

#define LZ4_MEMORY_USAGE LZ4_MEMORY_USAGE_DEFAULT

LZ4_MEMORY_USAGE : Can be selected at compile time, by setting LZ4_MEMORY_USAGE. Memory usage formula : N->2^N Bytes (examples : 10 -> 1KB; 12 -> 4KB ; 16 -> 64KB; 20 -> 1MB) Increasing memory usage improves compression ratio, generally at the cost of speed. Reduced memory usage may improve speed at the cost of ratio, thanks to better cache locality. Default value is 14, for 16KB, which nicely fits into most L1 caches.

Definition at line 169 of file lz4.h.

## LZ4_MEMORY_USAGE_DEFAULT

#define LZ4_MEMORY_USAGE_DEFAULT 14

Definition at line 174 of file lz4.h.

## LZ4_MEMORY_USAGE_MAX

#define LZ4_MEMORY_USAGE_MAX 20

Definition at line 175 of file lz4.h.

## LZ4_MEMORY_USAGE_MIN

#define LZ4_MEMORY_USAGE_MIN 10

Definition at line 173 of file lz4.h.

## LZ4_QUOTE

#define LZ4_QUOTE | ( |  | str | ) |

Value:
#str

Definition at line 144 of file lz4.h.

## LZ4_STREAM_MINSIZE

#define LZ4_STREAM_MINSIZE

Value:
((1UL << (LZ4_MEMORY_USAGE)) + \
32) /* static size, for inter-version compatibility */
LZ4_MEMORY_USAGE
#define LZ4_MEMORY_USAGE
Definition lz4.h:169

Definition at line 837 of file lz4.h.

## LZ4_STREAMDECODE_MINSIZE

#define LZ4_STREAMDECODE_MINSIZE 32

Definition at line 874 of file lz4.h.

## LZ4_VERSION_MAJOR

#define LZ4_VERSION_MAJOR 1 /* for breaking interface changes */

Definition at line 134 of file lz4.h.

## LZ4_VERSION_MINOR

#define LZ4_VERSION_MINOR

Value:
10 /* for new (non-breaking) interface capabilities \
*/

Definition at line 135 of file lz4.h.

## LZ4_VERSION_NUMBER

#define LZ4_VERSION_NUMBER

Value:
(LZ4_VERSION_MAJOR * 100 * 100 + LZ4_VERSION_MINOR * 100 + \
LZ4_VERSION_RELEASE)
LZ4_VERSION_RELEASE
#define LZ4_VERSION_RELEASE
Definition lz4.h:137
LZ4_VERSION_MAJOR
#define LZ4_VERSION_MAJOR
Definition lz4.h:134
LZ4_VERSION_MINOR
#define LZ4_VERSION_MINOR
Definition lz4.h:135

Definition at line 139 of file lz4.h.

Referenced by LZ4_versionString().

## LZ4_VERSION_RELEASE

#define LZ4_VERSION_RELEASE 0 /* for tweaks, bug-fixes, or development */

Definition at line 137 of file lz4.h.

## LZ4_VERSION_STRING

#define LZ4_VERSION_STRING LZ4_EXPAND_AND_QUOTE(LZ4_LIB_VERSION) /* requires v1.7.3+ */

Definition at line 146 of file lz4.h.

Referenced by LZ4_compressBound().

## LZ4LIB_API

#define LZ4LIB_API LZ4LIB_VISIBILITY

Definition at line 101 of file lz4.h.

Referenced by LZ4_compress(), LZ4_compress_continue(), LZ4_compress_limitedOutput(), LZ4_compress_limitedOutput_continue(), LZ4_compress_limitedOutput_withState(), LZ4_compress_withState(), LZ4_create(), LZ4_decompress_fast(), LZ4_decompress_fast_continue(), LZ4_decompress_fast_usingDict(), LZ4_decompress_fast_withPrefix64k(), LZ4_decompress_safe(), LZ4_decompress_safe_continue(), LZ4_decompress_safe_partial(), LZ4_decompress_safe_partial_usingDict(), LZ4_decompress_safe_usingDict(), LZ4_decompress_safe_withPrefix64k(), LZ4_freeStreamDecode(), LZ4_resetStreamState(), LZ4_setStreamDecode(), LZ4_sizeofStreamState(), LZ4_slideInputBuffer(), LZ4_uncompress(), and LZ4_uncompress_unknownOutputSize().

## LZ4LIB_VISIBILITY

#define LZ4LIB_VISIBILITY

Introduction

LZ4 is lossless compression algorithm, providing compression speed >500 MB/s per core, scalable with multi-cores CPU. It features an extremely fast decoder, with speed in multiple GB/s per core, typically reaching RAM speed limits on multi-core systems.

The LZ4 compression library provides in-memory compression and decompression functions. It gives full buffer control to user. Compression can be done in:

- a single step (described as Simple Functions)
- a single step, reusing a context (described in Advanced Functions)
- unbounded multiple steps (described as Streaming compression)

lz4.h generates and decodes LZ4-compressed blocks (doc/lz4_Block_format.md). Decompressing such a compressed block requires additional metadata. Exact metadata depends on exact decompression function. For the typical case of LZ4_decompress_safe(), metadata includes block's compressed size, and maximum bound of decompressed size. Each application is free to encode and pass such metadata in whichever way it wants.

lz4.h only handle blocks, it can not generate Frames.

Blocks are different from Frames (doc/lz4_Frame_format.md). Frames bundle both blocks and metadata in a specified manner. Embedding metadata is required for compressed data to be self-contained and portable. Frame format is delivered through a companion API, declared in lz4frame.h. The lz4 CLI can only manage frames.

Definition at line 89 of file lz4.h.

## Typedef Documentation

## LZ4_byte

typedef unsigned char LZ4_byte

Definition at line 815 of file lz4.h.

## LZ4_i8

typedef signed char LZ4_i8

Definition at line 814 of file lz4.h.

## LZ4_stream_t

typedef union LZ4_stream_u LZ4_stream_t

Definition at line 363 of file lz4.h.

## LZ4_stream_t_internal

typedef struct LZ4_stream_t_internal LZ4_stream_t_internal

LZ4_stream_t : Never ever use below internal definitions directly ! These definitions are not API/ABI safe, and may change in future versions. If you need static allocation, declare or allocate an LZ4_stream_t object.

Definition at line 826 of file lz4.h.

## LZ4_streamDecode_t

typedef union LZ4_streamDecode_u LZ4_streamDecode_t

Definition at line 528 of file lz4.h.

## LZ4_u16

typedef unsigned short LZ4_u16

Definition at line 816 of file lz4.h.

## LZ4_u32

typedef unsigned int LZ4_u32

Definition at line 817 of file lz4.h.

## Function Documentation

## LZ4_attach_dictionary()

void LZ4_attach_dictionary | ( | LZ4_stream_t * | workingStream,
|  | const LZ4_stream_t * | dictionaryStream )

LZ4_attach_dictionary() : stable since v1.10.0

This allows efficient re-use of a static dictionary multiple times.

Rather than re-loading the dictionary buffer into a working context before each compression, or copying a pre-loaded dictionary's LZ4_stream_t into a working LZ4_stream_t, this function introduces a no-copy setup mechanism, in which the working stream references `dictionaryStream` in-place.

Several assumptions are made about the state of `dictionaryStream`. Currently, only states which have been prepared by LZ4_loadDict() or LZ4_loadDictSlow() should be expected to work.

Alternatively, the provided `dictionaryStream` may be NULL, in which case any existing dictionary stream is unset.

If a dictionary is provided, it replaces any pre-existing stream history. The dictionary contents are the only history that can be referenced and logically immediately precede the data compressed in the first subsequent compression call.

The dictionary will only remain attached to the working stream through the first compression call, at the end of which it is cleared. `dictionaryStream` stream (and source buffer) must remain in-place / accessible / unchanged through the completion of the compression session.

Note: there is no equivalent LZ4_attach_*() method on the decompression side because there is no initialization cost, hence no need to share the cost across multiple sessions. To decompress LZ4 blocks using dictionary, attached or not, just employ the regular LZ4_setStreamDecode() for streaming, or the stateless LZ4_decompress_safe_usingDict() for one-shot decompression.

Definition at line 2035 of file lz4.c.

References _ld_slow.

## LZ4_compress()

int LZ4_compress | ( | const char * | src,
|  | char * | dest,
|  | int | srcSize )

Obsolete compression functions (since v1.7.3)

References LZ4_compress(), and LZ4LIB_API.

Referenced by LZ4_compress().

## LZ4_compress_continue()

int LZ4_compress_continue | ( | LZ4_stream_t * | LZ4_streamPtr,
|  | const char * | source,
|  | char * | dest,
|  | int | inputSize )

References LZ4_compress_continue(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_compress_continue().

## LZ4_compress_default()

int LZ4_compress_default | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity )

LZ4_compress_default() : Compresses 'srcSize' bytes from buffer 'src' into already allocated 'dst' buffer of size 'dstCapacity'. Compression is guaranteed to succeed if 'dstCapacity' >= LZ4_compressBound(srcSize). It also runs faster, so it's a recommended setting. If the function cannot compress 'src' into a more limited 'dst' budget, compression stops immediately, and the function result is zero. In which case, 'dst' content is undefined (invalid).

Parameters

  srcSize | max supported value is LZ4_MAX_INPUT_SIZE.
  dstCapacity | size of buffer 'dst' (which must be already allocated)

Returns
  the number of bytes written into buffer 'dst' (necessarily <= dstCapacity) or 0 if compression fails Note : This function is protected against buffer overflow scenarios (never writes outside 'dst' buffer, nor read outside 'source' buffer).

Definition at line 1808 of file lz4.c.

Referenced by G_lz4_compress().

## LZ4_compress_destSize()

int LZ4_compress_destSize | ( | const char * | src,
|  | char * | dst,
|  | int * | srcSizePtr,
|  | int | targetDstSize )

LZ4_compress_destSize() : Reverse the logic : compresses as much data as possible from 'src' buffer into already allocated buffer 'dst', of size >= 'dstCapacity'. This function either compresses the entire 'src' content into 'dst' if it's large enough, or fill 'dst' buffer completely with as much data as possible from 'src'. note: acceleration parameter is fixed to "default".

Parameters

  [in,out] | srcSizePtr | Initially contains size of input. Will be modified to indicate how many bytes where read from 'src' to fill 'dst'. New value is necessarily <= input value.

Returns
  Nb bytes written into 'dst' (necessarily <= dstCapacity) or 0 if compression fails.

Note : from v1.8.2 to v1.9.1, this function had a bug (fixed in v1.9.2+): the produced compressed content could, in specific circumstances, require to be decompressed into a destination buffer larger by at least 1 byte than the content to decompress. If an application uses LZ4_compress_destSize(), it's highly recommended to update liblz4 to v1.9.2 or better. If this can't be done or ensured, the receiving decompression function should provide a dstCapacity which is > decompressedSize, by at least 1 byte. See https://github.com/lz4/lz4/issues/859 for details

Definition at line 1865 of file lz4.c.

References r.

## LZ4_compress_fast()

int LZ4_compress_fast | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

LZ4_compress_fast() : Same as LZ4_compress_default(), but allows selection of "acceleration" factor. The larger the acceleration value, the faster the algorithm, but also the lesser the compression. It's a trade-off. It can be fine tuned, with each successive value providing roughly +~3% to speed. An acceleration value of "1" is the same as regular LZ4_compress_default() Values <= 0 will be replaced by LZ4_ACCELERATION_DEFAULT (currently == 1, see lz4.c). Values > LZ4_ACCELERATION_MAX will be replaced by LZ4_ACCELERATION_MAX (currently == 65537, see lz4.c).

Definition at line 1786 of file lz4.c.

## LZ4_compress_fast_continue()

int LZ4_compress_fast_continue | ( | LZ4_stream_t * | streamPtr,
|  | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

LZ4_compress_fast_continue() : Compress 'src' content using data from previously compressed blocks, for better compression ratio. 'dst' buffer must be already allocated. If dstCapacity >= LZ4_compressBound(srcSize), compression is guaranteed to succeed, and runs faster.

Returns
  size of compressed block or 0 if there is an error (typically, cannot fit into 'dst').

Note 1 : Each invocation to LZ4_compress_fast_continue() generates a new block. Each block has precise boundaries. Each block must be decompressed separately, calling LZ4_decompress_*() with relevant metadata. It's not possible to append blocks together and expect a single invocation of LZ4_decompress_*() to decompress them together.

Note 2 : The previous 64KB of source data is assumed to remain present, unmodified, at same address in memory !

Note 3 : When input is structured as a double-buffer, each buffer can have any size, including < 64 KB. Make sure that buffers are separated, by at least one byte. This construction ensures that each block only depends on previous block.

Note 4 : If input buffer is a ring-buffer, it can have any size, including < 64 KB.

Note 5 : After an error, the stream status is undefined (invalid), it can only be reset or freed.

Definition at line 2087 of file lz4.c.

## LZ4_compress_fast_extState()

int LZ4_compress_fast_extState | ( | void * | state,
|  | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | int | acceleration )

Definition at line 1666 of file lz4.c.

## LZ4_compress_limitedOutput()

int LZ4_compress_limitedOutput | ( | const char * | src,
|  | char * | dest,
|  | int | srcSize,
|  | int | maxOutputSize )

References LZ4_compress_limitedOutput(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_compress_limitedOutput().

## LZ4_compress_limitedOutput_continue()

int LZ4_compress_limitedOutput_continue | ( | LZ4_stream_t * | LZ4_streamPtr,
|  | const char * | source,
|  | char * | dest,
|  | int | inputSize,
|  | int | maxOutputSize )

References LZ4_compress_limitedOutput_continue(), and LZ4LIB_API.

Referenced by LZ4_compress_limitedOutput_continue().

## LZ4_compress_limitedOutput_withState()

int LZ4_compress_limitedOutput_withState | ( | void * | state,
|  | const char * | source,
|  | char * | dest,
|  | int | inputSize,
|  | int | maxOutputSize )

References LZ4_compress_limitedOutput_withState(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_compress_limitedOutput_withState().

## LZ4_compress_withState()

int LZ4_compress_withState | ( | void * | state,
|  | const char * | source,
|  | char * | dest,
|  | int | inputSize )

References LZ4_compress_withState(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_compress_withState().

## LZ4_compressBound()

int LZ4_compressBound | ( | int | inputSize | ) |

LZ4_compressBound() : Provides the maximum size that LZ4 compression may output in a "worst case" scenario (input data not compressible) This function is primarily useful for memory allocation purposes (destination buffer size). Macro LZ4_COMPRESSBOUND() is also provided for compilation-time evaluation (stack memory allocation for example). Note that LZ4_compress_default() compresses faster when dstCapacity is >= LZ4_compressBound(srcSize)

Parameters

  inputSize | max supported value is LZ4_MAX_INPUT_SIZE

Returns
  maximum output size in a "worst case" scenario or 0, if input size is incorrect (too large or negative)

Definition at line 879 of file lz4.c.

References LZ4_VERSION_STRING.

Referenced by G_lz4_compress_bound(), and LZ4_compress_fast_extState_fastReset().

## LZ4_create()

void * LZ4_create | ( | char * | inputBuffer | ) |

References LZ4_create(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_create().

## LZ4_createStream()

LZ4_stream_t * LZ4_createStream | ( | void |  | ) |

Note about RC_INVOKED

- RC_INVOKED is predefined symbol of rc.exe (the resource compiler which is part of MSVC/Visual Studio). https://docs.microsoft.com/en-us/windows/win32/menurc/predefined-macros
- Since rc.exe is a legacy compiler, it truncates long symbol (> 30 chars) and reports warning "RC4011: identifier truncated".
- To eliminate the warning, we surround long preprocessor symbol with "#if !defined(RC_INVOKED) ... #endif" block that means "skip this block when rc.exe is trying to read it".

Definition at line 1892 of file lz4.c.

References ALLOC, DEBUGLOG, LZ4_initStream(), LZ4_STATIC_ASSERT, and NULL.

## LZ4_createStreamDecode()

LZ4_streamDecode_t * LZ4_createStreamDecode | ( | void |  | ) |

LZ4_createStreamDecode() and LZ4_freeStreamDecode() : creation / destruction of streaming decompression tracking context. A tracking context can be re-used multiple times.

## LZ4_decoderRingBufferSize()

int LZ4_decoderRingBufferSize | ( | int | maxBlockSize | ) |

LZ4_decoderRingBufferSize() : v1.8.2+ Note : in a ring buffer scenario (optional), blocks are presumed decompressed next to each other up to the moment there is not enough remaining space for next block (remainingSize < maxBlockSize), at which stage it resumes from beginning of ring buffer. When setting such a ring buffer for streaming decompression, provides the minimum size of this ring buffer to be compatible with any source respecting maxBlockSize condition.

Returns
  : minimum ring buffer size, or 0 if there is an error (invalid maxBlockSize).

## LZ4_decompress_fast()

int LZ4_decompress_fast | ( | const char * | src,
|  | char * | dst,
|  | int | originalSize )

Obsolete LZ4_decompress_fast variants (since v1.9.0) : These functions used to be faster than LZ4_decompress_safe(), but this is no longer the case. They are now slower. This is because LZ4_decompress_fast() doesn't know the input size, and therefore must progress more cautiously into the input buffer to not read beyond the end of block. On top of that LZ4_decompress_fast() is not protected vs malformed or malicious inputs, making it a security liability. As a consequence, LZ4_decompress_fast() is strongly discouraged, and deprecated.

The last remaining LZ4_decompress_fast() specificity is that it can decompress a block without knowing its compressed size. Such functionality can be achieved in a more secure manner by employing LZ4_decompress_safe_partial().

Parameters:

Parameters

  originalSize | is the uncompressed size to regenerate. dst must be already allocated, its size must be >= 'originalSize' bytes.

Returns
  number of bytes read from source buffer (== compressed size). The function expects to finish at block's end exactly. If the source stream is detected malformed, the function stops decoding and returns a negative result.

note : LZ4_decompress_fast*() requires originalSize. Thanks to this information, it never writes past the output buffer. However, since it doesn't know its 'src' size, it may read an unknown amount of input, past input buffer bounds. Also, since match offsets are not validated, match reads from 'src' may underflow too. These issues never happen if input (compressed) data is correct. But they may happen if input data is invalid (error or intentional tampering). As a consequence, use these functions in trusted environments with trusted data only.

References LZ4_decompress_fast(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_decompress_fast().

## LZ4_decompress_fast_continue()

int LZ4_decompress_fast_continue | ( | LZ4_streamDecode_t * | LZ4_streamDecode,
|  | const char * | src,
|  | char * | dst,
|  | int | originalSize )

References LZ4_decompress_fast_continue(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_decompress_fast_continue().

## LZ4_decompress_fast_usingDict()

int LZ4_decompress_fast_usingDict | ( | const char * | src,
|  | char * | dst,
|  | int | originalSize,
|  | const char * | dictStart,
|  | int | dictSize )

References LZ4_decompress_fast_usingDict(), LZ4_resetStream(), and LZ4LIB_API.

Referenced by LZ4_decompress_fast_usingDict().

## LZ4_decompress_fast_withPrefix64k()

int LZ4_decompress_fast_withPrefix64k | ( | const char * | src,
|  | char * | dst,
|  | int | originalSize )

References LZ4_decompress_fast_withPrefix64k(), LZ4_DEPRECATED, and LZ4LIB_API.

Referenced by LZ4_decompress_fast_withPrefix64k().

## LZ4_decompress_safe()

int LZ4_decompress_safe | ( | const char * | src,
|  | char * | dst,
|  | int | compressedSize,
|  | int | dstCapacity )

LZ4_decompress_safe() :

Parameters

  src |
  dst |
  compressedSize | is the exact complete size of the compressed block.
  dstCapacity | is the size of destination buffer (which must be already allocated), presumed an upper bound of decompressed size.

Returns
  the number of bytes decompressed into destination buffer (necessarily <= dstCapacity) If destination buffer is not large enough, decoding will stop and output an error code (negative value). If the source stream is detected malformed, the function will stop decoding and return a negative result.

Note 1 : This function is protected against malicious data packets : it will never write outside 'dst' buffer, nor read outside 'source' buffer, even if the compressed block is maliciously modified to order the decoder to do these actions. In such case, the decoder stops immediately, andconsiders the compressed block malformed.

Note 2 : compressedSize and dstCapacity must be provided to the function, the compressed block does not contain them. The implementation is free to send / store / derive this information in whichever way is most beneficial. If there is a need for a different format which bundles together both compressed data and its metadata, consider looking at lz4frame.h instead.

References LZ4LIB_API.

Referenced by G_lz4_expand().

## LZ4_decompress_safe_continue()

int LZ4_decompress_safe_continue | ( | LZ4_streamDecode_t * | LZ4_streamDecode,
|  | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity )

LZ4_decompress_safe_continue() : This decoding function allows decompression of consecutive blocks in "streaming" mode. The difference with the usual independent blocks is that new blocks are allowed to find references into former blocks. A block is an unsplittable entity, and must be presented entirely to the decompression function. LZ4_decompress_safe_continue() only accepts one block at a time. It's modeled after LZ4_decompress_safe() and behaves similarly.

Parameters

  LZ4_streamDecode | decompression state, tracking the position in memory of past data
  compressedSize | exact complete size of one compressed block.
  dstCapacity | size of destination buffer (which must be already allocated), must be an upper bound of decompressed size.

Returns
  number of bytes decompressed into destination buffer (necessarily <= `dstCapacity`) If destination buffer is not large enough, decoding will stop and output an error code (negative value). If the source stream is detected malformed, the function will stop decoding and return a negative result.

The last 64KB of previously decoded data must remain available and unmodified at the memory position where they were previously decoded. If less than 64KB of data has been decoded, all the data must be present.

Special : if decompression side sets a ring buffer, it must respect one of the following conditions :

- Decompression buffer size is at least LZ4_decoderRingBufferSize(maxBlockSize). maxBlockSize is the maximum size of any single block. It can have any value > 16 bytes. In which case, encoding and decoding buffers do not need to be synchronized. Actually, data can be produced by any source compliant with LZ4 format specification, and respecting maxBlockSize.
- Synchronized mode : Decompression buffer size is exactly the same as compression buffer size, and follows exactly same update rule (block boundaries at same positions), and decoding function is provided with exact decompressed size of each block (exception for last block of the stream), then decoding & encoding ring buffer can have any size, including small ones ( < 64 KB).
- Decompression buffer is larger than encoding buffer, by a minimum of maxBlockSize more bytes. In which case, encoding and decoding buffers do not need to be synchronized, and encoding ring buffer can have any size, including small ones ( < 64 KB).

Whenever these conditions are not possible, save the last 64KB of decoded data into a safe buffer where it can't be modified during decompression, then indicate where this data is saved using LZ4_setStreamDecode(), before decompressing next block.

References LZ4LIB_API.

## LZ4_decompress_safe_partial()

int LZ4_decompress_safe_partial | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | targetOutputSize,
|  | int | dstCapacity )

LZ4_decompress_safe_partial() : Decompress an LZ4 compressed block, of size 'srcSize' at position 'src', into destination buffer 'dst' of size 'dstCapacity'. Up to 'targetOutputSize' bytes will be decoded. The function stops decoding on reaching this objective. This can be useful to boost performance whenever only the beginning of a block is required.

Returns
  the number of bytes decoded in dst (necessarily <= `targetOutputSize`) If source stream is detected malformed, function returns a negative result.

Note 1 :

Returns
  can be < `targetOutputSize`, if compressed block contains less data.

Note 2 : `targetOutputSize` must be <= `dstCapacity`

Note 3 : this function effectively stops decoding on reaching `targetOutputSize`, so `dstCapacity` is kind of redundant. This is because in older versions of this function, decoding operation would still write complete sequences. Therefore, there was no guarantee that it would stop writing at exactly `targetOutputSize`, it could write more bytes, though only up to `dstCapacity`. Some "margin" used to be required for this operation to work properly. Thankfully, this is no longer necessary. The function nonetheless keeps the same signature, in an effort to preserve API compatibility.

Note 4 : If `srcSize` is the exact size of the block, then `targetOutputSize` can be any value, including larger than the block's decompressed size. The function will, at most, generate block's decompressed size.

Note 5 : If `srcSize` is larger than block's compressed size, then `targetOutputSize` MUST be <= block's decompressed size. Otherwise, silent corruption will occur.

References LZ4LIB_API.

## LZ4_decompress_safe_partial_usingDict()

int LZ4_decompress_safe_partial_usingDict | ( | const char * | src,
|  | char * | dst,
|  | int | compressedSize,
|  | int | targetOutputSize,
|  | int | maxOutputSize,
|  | const char * | dictStart,
|  | int | dictSize )

LZ4_decompress_safe_partial_usingDict() : Behaves the same as LZ4_decompress_safe_partial() with the added ability to specify a memory segment for past data. Performance tip : Decompression speed can be substantially increased when dst == dictStart + dictSize.

References LZ4LIB_API.

## LZ4_decompress_safe_usingDict()

int LZ4_decompress_safe_usingDict | ( | const char * | src,
|  | char * | dst,
|  | int | srcSize,
|  | int | dstCapacity,
|  | const char * | dictStart,
|  | int | dictSize )

LZ4_decompress_safe_usingDict() : Works the same as a combination of LZ4_setStreamDecode() followed by LZ4_decompress_safe_continue() However, it's stateless: it doesn't need any LZ4_streamDecode_t state. Dictionary is presumed stable : it must remain accessible and unmodified during decompression. Performance tip : Decompression speed can be substantially increased when dst == dictStart + dictSize.

References LZ4LIB_API.

## LZ4_decompress_safe_withPrefix64k()

int LZ4_decompress_safe_withPrefix64k | ( | const char * | src,
|  | char * | dst,
|  | int | compressedSize,
|  | int | maxDstSize )

Obsolete streaming decoding functions (since v1.7.0)

References LZ4_decompress_safe_withPrefix64k(), and LZ4LIB_API.

Referenced by LZ4_decompress_safe_withPrefix64k().

## LZ4_freeStream()

int LZ4_freeStream | ( | LZ4_stream_t * | streamPtr | ) |

Definition at line 1946 of file lz4.c.

## LZ4_freeStreamDecode()

int LZ4_freeStreamDecode | ( | LZ4_streamDecode_t * | LZ4_stream | ) |

References LZ4LIB_API.

## LZ4_initStream()

LZ4_stream_t * LZ4_initStream | ( | void * | stateBuffer,
|  | size_t | size )

LZ4_initStream() : v1.9.0+ An LZ4_stream_t structure must be initialized at least once. This is automatically done when invoking LZ4_createStream(), but it's not when the structure is simply declared on stack (for example).

Use LZ4_initStream() to properly initialize a newly declared LZ4_stream_t. It can also initialize any arbitrary buffer of sufficient size, and will

Returns
  a pointer of proper type upon initialization.

Note : initialization fails if size and alignment conditions are not respected. In which case, the function will

Returns
  NULL. Note2: An LZ4_stream_t structure guarantees correct alignment and size. Note3: Before v1.9.0, use LZ4_resetStream() instead

Definition at line 1917 of file lz4.c.

Referenced by LZ4_createStream().

## LZ4_loadDict()

int LZ4_loadDict | ( | LZ4_stream_t * | streamPtr,
|  | const char * | dictionary,
|  | int | dictSize )

LZ4_loadDict() : Use this function to reference a static dictionary into LZ4_stream_t. The dictionary must remain available during compression. LZ4_loadDict() triggers a reset, so any previous data will be forgotten. The same dictionary will have to be loaded on decompression side for successful decoding. Dictionary are useful for better compression of small data (KB range). While LZ4 itself accepts any input as dictionary, dictionary efficiency is also a topic. When in doubt, employ the Zstandard's Dictionary Builder. Loading a size of 0 is allowed, and is the same as reset.

Returns
  loaded dictionary size, in bytes (note: only the last 64 KB are loaded)

Definition at line 2024 of file lz4.c.

## LZ4_loadDictSlow()

int LZ4_loadDictSlow | ( | LZ4_stream_t * | streamPtr,
|  | const char * | dictionary,
|  | int | dictSize )

LZ4_loadDictSlow() : v1.10.0+ Same as LZ4_loadDict(), but uses a bit more cpu to reference the dictionary content more thoroughly. This is expected to slightly improve compression ratio. The extra-cpu cost is likely worth it if the dictionary is re-used across multiple sessions.

Returns
  loaded dictionary size, in bytes (note: only the last 64 KB are loaded)

Definition at line 2029 of file lz4.c.

References _ld_fast.

## LZ4_resetStream()

void LZ4_resetStream | ( | LZ4_stream_t * | streamPtr | ) |

LZ4_resetStream() : An LZ4_stream_t structure must be initialized at least once. This is done with LZ4_initStream(), or LZ4_resetStream(). Consider switching to LZ4_initStream(), invoking LZ4_resetStream() will trigger deprecation warnings in the future.

Definition at line 1934 of file lz4.c.

References DEBUGLOG.

Referenced by LZ4_decompress_fast_usingDict().

## LZ4_resetStream_fast()

void LZ4_resetStream_fast | ( | LZ4_stream_t * | streamPtr | ) |

LZ4_resetStream_fast() : v1.9.0+ Use this to prepare an LZ4_stream_t for a new chain of dependent blocks (e.g., LZ4_compress_fast_continue()).

An LZ4_stream_t must be initialized once before usage. This is automatically done when created by LZ4_createStream(). However, should the LZ4_stream_t be simply declared on stack (for example), it's necessary to initialize it first, using LZ4_initStream().

After init, start any new stream with LZ4_resetStream_fast(). A same LZ4_stream_t can be re-used multiple times consecutively and compress multiple streams, provided that it starts each new stream with LZ4_resetStream_fast().

LZ4_resetStream_fast() is much faster than LZ4_initStream(), but is not compatible with memory regions containing garbage data.

Note: it's only useful to call LZ4_resetStream_fast() in the context of streaming compression. The extState functions perform their own resets. Invoking LZ4_resetStream_fast() before is redundant, and even counterproductive.

Definition at line 1940 of file lz4.c.

## LZ4_resetStreamState()

int LZ4_resetStreamState | ( | void * | state,
|  | char * | inputBuffer )

References LZ4_DEPRECATED, LZ4_resetStreamState(), and LZ4LIB_API.

Referenced by LZ4_resetStreamState().

## LZ4_saveDict()

int LZ4_saveDict | ( | LZ4_stream_t * | LZ4_dict,
|  | char * | safeBuffer,
|  | int | dictSize )

LZ4_saveDict() : If last 64KB data cannot be guaranteed to remain available at its current memory location, save it into a safer place (char* safeBuffer). This is schematically equivalent to a memcpy() followed by LZ4_loadDict(), but is much faster, because LZ4_saveDict() doesn't need to rebuild tables.

Returns
  saved dictionary size in bytes (necessarily <= maxDictSize), or 0 if error.

LZ4_saveDict() : If previously compressed data block is not guaranteed to remain available at its memory location, save it into a safer place (char* safeBuffer). Note : no need to call LZ4_loadDict() afterwards, dictionary is immediately usable, one can therefore call LZ4_compress_fast_continue() right after.

Returns
  : saved dictionary size in bytes (necessarily <= dictSize), or 0 if error.

Definition at line 2238 of file lz4.c.

References assert, DEBUGLOG, LZ4_stream_t_internal::dictionary, LZ4_stream_t_internal::dictSize, LZ4_stream_u::internal_donotuse, KB, LZ4_memmove, and NULL.

## LZ4_setStreamDecode()

int LZ4_setStreamDecode | ( | LZ4_streamDecode_t * | LZ4_streamDecode,
|  | const char * | dictionary,
|  | int | dictSize )

LZ4_setStreamDecode() : An LZ4_streamDecode_t context can be allocated once and re-used multiple times. Use this function to start decompression of a new stream of blocks. A dictionary can optionally be set. Use NULL or size 0 for a reset order. Dictionary is presumed stable : it must remain accessible and unmodified during next decompression.

Returns
  1 if OK, 0 if error

References LZ4LIB_API.

## LZ4_sizeofState()

int LZ4_sizeofState | ( | void |  | ) |

LZ4_compress_fast_extState() : Same as LZ4_compress_fast(), using an externally allocated memory space for its state. Use LZ4_sizeofState() to know how much memory must be allocated, and allocate it on 8-bytes boundaries (using malloc() typically). Then, provide this buffer as void* state to compression function.

Definition at line 883 of file lz4.c.

References LZ4_COMPRESSBOUND.

## LZ4_sizeofStreamState()

int LZ4_sizeofStreamState | ( | void |  | ) |

References LZ4_DEPRECATED, LZ4_sizeofStreamState(), and LZ4LIB_API.

Referenced by LZ4_sizeofStreamState().

## LZ4_slideInputBuffer()

char * LZ4_slideInputBuffer | ( | void * | state | ) |

References LZ4_DEPRECATED, LZ4_slideInputBuffer(), and LZ4LIB_API.

Referenced by LZ4_slideInputBuffer().

## LZ4_uncompress()

int LZ4_uncompress | ( | const char * | source,
|  | char * | dest,
|  | int | outputSize )

Obsolete decompression functions (since v1.8.0)

References LZ4_DEPRECATED, LZ4_uncompress(), and LZ4LIB_API.

Referenced by LZ4_uncompress().

## LZ4_uncompress_unknownOutputSize()

int LZ4_uncompress_unknownOutputSize | ( | const char * | source,
|  | char * | dest,
|  | int | isize,
|  | int | maxOutputSize )

References LZ4_DEPRECATED, LZ4_uncompress_unknownOutputSize(), and LZ4LIB_API.

Referenced by LZ4_uncompress_unknownOutputSize().

## LZ4_versionNumber()

int LZ4_versionNumber | ( | void |  | ) |

library version number; useful to check dll version; requires v1.3.0+

Definition at line 871 of file lz4.c.

## LZ4_versionString()

const char * LZ4_versionString | ( | void |  | ) |

library version string; useful to check dll version; requires v1.7.5+

Definition at line 875 of file lz4.c.

References LZ4_VERSION_NUMBER.